/*
 * Copyright (C) 2009  Miriam Ruiz <little_miry@yahoo.es>
 * Copyright (C) 2006  Nemanja Trifunovic
 *
 * http://utfcpp.sourceforge.net/
 * http://sourceforge.net/projects/utfcpp
 * 
 * Permission is hereby granted, free of charge, to any person or organization
 * obtaining a copy of the software and accompanying documentation covered by
 * this license (the "Software") to use, reproduce, display, distribute,
 * execute, and transmit the Software, and to prepare derivative works of the
 * Software, and to permit third-parties to whom the Software is furnished to
 * do so, all subject to the following:
 * 
 * The copyright notices in the Software and this entire statement, including
 * the above license grant, this restriction and the following disclaimer,
 * must be included in all copies of the Software, in whole or in part, and
 * all derivative works of the Software, unless such copies or derivative
 * works are solely in the form of machine-executable object code generated by
 * a source language processor.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
 * SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
 * FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include "../common.h"
#include "checked.h"
#include "unchecked.h"

#include <vector>

#ifdef UNIT_TEST
TEST_FUNCTION TestCuUTF8CPP(CuTest* tc)
{
	// Functions From utf8 Namespace

	// utf8::append
	{
		unsigned char u[5] = {0,0,0,0,0};
		unsigned char *end = utf8::append(0x0448, u);
		CuAssertTrue(tc, u[0] == 0xd1 && u[1] == 0x88 && u[2] == 0 && u[3] == 0 && u[4] == 0);
		CuAssertTrue(tc, end != NULL);
	}

	// utf8::next
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars;
		int cp = utf8::next(w, twochars + 6);
		CuAssertTrue(tc, cp == 0x65e5);
		CuAssertTrue(tc, w == twochars + 3);
	}

	// utf8::peek_next
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars;
		int cp = utf8::peek_next(w, twochars + 6);
		CuAssertTrue(tc, cp == 0x65e5);
		CuAssertTrue(tc, w == twochars);
	}

	// utf8::prior
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars + 3;
		int cp = utf8::prior (w, twochars);
		CuAssertTrue(tc, cp == 0x65e5);
		CuAssertTrue(tc, w == twochars);
	}

	// utf8::advance
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars;
		utf8::advance (w, 2, twochars + 6);
		CuAssertTrue(tc, w == twochars + 5);
	}

	// utf8::distance
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		size_t dist = utf8::distance(twochars, twochars + 5);
		CuAssertTrue(tc, dist == 2);
	}

	// utf8::utf16to8
	{
		unsigned short utf16string[] = {0x41, 0x0448, 0x65e5, 0xd834, 0xdd1e};
		std::vector<unsigned char> utf8result;
		utf8::utf16to8(utf16string, utf16string + 5, back_inserter(utf8result));
		CuAssertTrue(tc, utf8result.size() == 10);
	}

	// utf8::utf8to16
	{
		char utf8_with_surrogates[] = "\xe6\x97\xa5\xd1\x88\xf0\x9d\x84\x9e";
		std::vector <unsigned short> utf16result;
		utf8::utf8to16(utf8_with_surrogates, utf8_with_surrogates + 9, back_inserter(utf16result));
		CuAssertTrue(tc, utf16result.size() == 4);
		CuAssertTrue(tc, utf16result[2] == 0xd834);
		CuAssertTrue(tc, utf16result[3] == 0xdd1e);
	}

	// utf8::utf32to8
	{
		int utf32string[] = {0x448, 0x65E5, 0x10346, 0};
		std::vector<unsigned char> utf8result;
		utf8::utf32to8(utf32string, utf32string + 3, back_inserter(utf8result));
		CuAssertTrue(tc, utf8result.size() == 9);
	}

	// utf8::utf8to32
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		std::vector<int> utf32result;
		utf8::utf8to32(twochars, twochars + 5, back_inserter(utf32result));
		CuAssertTrue(tc, utf32result.size() == 2);
	}

	// utf8::find_invalid
	{
		char utf_invalid[] = "\xe6\x97\xa5\xd1\x88\xfa";
		char *invalid = utf8::find_invalid(utf_invalid, utf_invalid + 6);
		CuAssertTrue(tc, invalid == utf_invalid + 5);
	}

	// utf8::is_valid
	{
		char utf_invalid[] = "\xe6\x97\xa5\xd1\x88\xfa";
		bool bvalid = utf8::is_valid(utf_invalid, utf_invalid + 6);
		CuAssertTrue(tc, bvalid == false);
	}

	// utf8::replace_invalid
	{
		const char invalid_sequence[] = "a\x80\xe0\xa0\xc0\xaf\xed\xa0\x80z";
		std::vector<char> replace_invalid_result;
		utf8::replace_invalid (invalid_sequence, invalid_sequence + sizeof(invalid_sequence), back_inserter(replace_invalid_result), '?');
		bool bvalid = utf8::is_valid(replace_invalid_result.begin(), replace_invalid_result.end());
		CuAssertTrue(tc, bvalid);
		const char *fixed_invalid_sequence = "a????z";
		CuAssertTrue(tc, std::equal(replace_invalid_result.begin(), replace_invalid_result.end(), fixed_invalid_sequence));
	}

	// utf8::is_bom
	{
		unsigned char byte_order_mark[] = {0xef, 0xbb, 0xbf};
		bool bbom = utf8::is_bom(byte_order_mark);
		CuAssertTrue(tc, bbom == true);
	}

	// Types From utf8 Namespace

	// utf8::iterator
	{
		const char *threechars = "\xf0\x90\x8d\x86\xe6\x97\xa5\xd1\x88";
		utf8::iterator<const char*> it(threechars, threechars, threechars + 9);
		utf8::iterator<const char*> it2 = it;
		CuAssertTrue(tc, it2 == it);
		CuAssertTrue(tc, *it == 0x10346);
		CuAssertTrue(tc, *(++it) == 0x65e5);
		CuAssertTrue(tc, (*it++) == 0x65e5);
		CuAssertTrue(tc, *it == 0x0448);
		CuAssertTrue(tc, it != it2);
		utf8::iterator<const char*> endit (threechars + 9, threechars, threechars + 9);  
		CuAssertTrue(tc, ++it == endit);
		CuAssertTrue(tc, *(--it) == 0x0448);
		CuAssertTrue(tc, (*it--) == 0x0448);
		CuAssertTrue(tc, *it == 0x65e5);
		CuAssertTrue(tc, --it == utf8::iterator<const char*>(threechars, threechars, threechars + 9));
		CuAssertTrue(tc, *it == 0x10346);
	}

	// Functions From utf8::unchecked Namespace

	// utf8::unchecked::append
	{
		unsigned char u[5] = {0,0,0,0,0};
		unsigned char *end = utf8::unchecked::append(0x0448, u);
		CuAssertTrue(tc, u[0] == 0xd1 && u[1] == 0x88 && u[2] == 0 && u[3] == 0 && u[4] == 0);
		CuAssertTrue(tc, end != NULL);
	}

	// utf8::unchecked::next
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars;
		int cp = utf8::unchecked::next(w);
		CuAssertTrue(tc, cp == 0x65e5);
		CuAssertTrue(tc, w == twochars + 3);
	}

	// utf8::unchecked::peek_next
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars;
		int cp = utf8::unchecked::peek_next(w);
		CuAssertTrue(tc, cp == 0x65e5);
		CuAssertTrue(tc, w == twochars);
	}

	// utf8::unchecked::prior
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars + 3;
		int cp = utf8::unchecked::prior (w);
		CuAssertTrue(tc, cp == 0x65e5);
		CuAssertTrue(tc, w == twochars);
	}

	// utf8::unchecked::advance
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		const char *w = twochars;
		utf8::unchecked::advance (w, 2);
		CuAssertTrue(tc, w == twochars + 5);
	}

	// utf8::unchecked::distance
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		size_t dist = utf8::unchecked::distance(twochars, twochars + 5);
		CuAssertTrue(tc, dist == 2);
	}

	// utf8::unchecked::utf16to8
	{
		unsigned short utf16string[] = {0x41, 0x0448, 0x65e5, 0xd834, 0xdd1e};
		std::vector<unsigned char> utf8result;
		utf8::unchecked::utf16to8(utf16string, utf16string + 5, back_inserter(utf8result));
		CuAssertTrue(tc, utf8result.size() == 10);    
	}

	// utf8::unchecked::utf8to16
	{
		const char utf8_with_surrogates[] = "\xe6\x97\xa5\xd1\x88\xf0\x9d\x84\x9e";
		std::vector <unsigned short> utf16result;
		utf8::unchecked::utf8to16(utf8_with_surrogates, utf8_with_surrogates + 9, back_inserter(utf16result));
		CuAssertTrue(tc, utf16result.size() == 4);
		CuAssertTrue(tc, utf16result[2] == 0xd834);
		CuAssertTrue(tc, utf16result[3] == 0xdd1e);
	}

	// utf8::unchecked::utf32to8
	{
		int utf32string[] = {0x448, 0x65e5, 0x10346, 0};
		std::vector<unsigned char> utf8result;
		utf8::unchecked::utf32to8(utf32string, utf32string + 3, back_inserter(utf8result));
		CuAssertTrue(tc, utf8result.size() == 9);
	}

	// utf8::unchecked::utf8to32
	{
		const char *twochars = "\xe6\x97\xa5\xd1\x88";
		std::vector<int> utf32result;
		utf8::unchecked::utf8to32(twochars, twochars + 5, back_inserter(utf32result));
		CuAssertTrue(tc, utf32result.size() == 2);
	}

	// Types From utf8::unchecked Namespace

	// utf8::iterator
	{
		const char *threechars = "\xf0\x90\x8d\x86\xe6\x97\xa5\xd1\x88";
		utf8::unchecked::iterator<const char*> un_it(threechars);
		utf8::unchecked::iterator<const char*> un_it2 = un_it;
		CuAssertTrue(tc, un_it2 == un_it);
		CuAssertTrue(tc, *un_it == 0x10346);
		CuAssertTrue(tc, *(++un_it) == 0x65e5);
		CuAssertTrue(tc, (*un_it++) == 0x65e5);
		CuAssertTrue(tc, *un_it == 0x0448);
		CuAssertTrue(tc, un_it != un_it2);
		utf8::unchecked::iterator<const char*> un_endit (threechars + 9);  
		CuAssertTrue(tc, ++un_it == un_endit);
		CuAssertTrue(tc, *(--un_it) == 0x0448);
		CuAssertTrue(tc, (*un_it--) == 0x0448);
		CuAssertTrue(tc, *un_it == 0x65e5);
		CuAssertTrue(tc, --un_it == utf8::unchecked::iterator<const char*>(threechars));
		CuAssertTrue(tc, *un_it == 0x10346);
	}
}
#endif
